// ПРОГРАММА УПРАВЛЕНИЯ КОНТРОЛЛЕРОМ "РАЗЛИВАЛЬЩИК - BIOLOID" (ARDUINO PRO 5V, 16MHZ)


#include <Wire.h> //I2C interface
#include <EEPROM.h>
//  value = EEPROM.read(address);
//  EEPROM.write(addr, val);

// НАЗНАЧЕНИЕ ПОРТОВ:
//RXD //digital pin 0
//TXD //digital pin 1
int MoneyInt=0; //input digital pin 2, прерывание датчика монеты (Если первым будет #define, компилятор выдаст ошибку!)
#define WTBUSY 3  //int ReservInt=1; //input digital pin 3, резервное прерывание или PWM
#define WTSDA 4 //output digital pin 4 Управление проигрывателем звуков (WTV)
#define WTSCL 5 //output digital pin 5 Управление проигрывателем звуков (WTV)
#define PumpPort 6 //output PWM pin 6 управление насосом
#define txen  7 //output digital pin 7 (red) Разрешение передачи RS232
#define rxen  8 //output digital pin 8 (white) Разрешение приема RS232
#define blue 9 //output PWM pin 9 подсветка стакана
#define red 10 //output PWM pin 10 подсветка стакана
#define green 11 //output PWM pin 11 подсветка стакана
#define TestButton  12 //input digital pin 12 отладочная кнопка
#define led 13 //output digital pin 13 Тестовый светодиод Ардуино
#define Contr12 0 //input analog pin 0 Контроль напряжения после рубильника (порт A0)
#define CupContr 1 //input analog pin 1 Контроль наличия фужера (порт A1)
#define MoveSensor  16// input digital pin 16 (порт A2) датчик движения.
#define MoneyLed 17 //output digital pin 17 подсветка монетоприемника (порт A3)
// I2C interface SDA (порт A4) 
// I2C interface SCL (порт A5)

//  ОБЩИЕ НАСТРОЙКИ
boolean OtladkaFlag=false;
//boolean OtladkaFlag=true;
#define SCANCYC 1 //время цикла опроса/индикации в мС (минимально возможная пауза)
unsigned int SafeLeng=10; // адрес сохранения текущего языка
boolean InitFlag=false; // исходное состояние
boolean TestBtnLock=false; // блокировка тестовой кнопки
//Bit Macros
#define SETBIT(x,n) ((x)|=1L<<(n)) 
#define CLEARBIT(x,n) ((x)&=~(1L<<(n))) 
#define GETBIT(x,n) ((x)&1L<<(n)) 

//DINAMIXEL PROTOCOL
#define startByte 0xFF //стартовый байт начала пакета
#define MyID 21		// уникальный индетификатор
#define Rlen 4  //длина пакета от BIOLOID
#define Wlen 3  //длина пакета от ARDUINO
#define ReadData 2 //команда чтения из регистра
#define WriteData 3 // команда записи в регистр
#define ErByte 0	// код ошибки (не используется)
byte DatosBioloid[]={
  startByte,startByte,MyID,Rlen,0,0,0,0,0}; // Обращение к Ардуино, как к мотору AX12 (Instruction Packet)
int CheckCount=0; // счетчик совпавших байт
boolean DatosFlag=false; //Получен пакет данных

byte RobotOldStatus=0;
byte RobotStatus=0; // Информационный байт, полученный от BIOLOID
// 10- робот в исходной позиции (сидит, ждет)
// 20- робот находится в движении
// 25- робот закончил движение
// 30...39 - робот "произносит" фразу с заданным номером
// 40- робот готов к наливу
// 45- робот ожидает следующий бокал
// 50- аварийный останов налива
// 100 - аварийный останов программы.

byte ArdStatus=0;  // Статус  байт, отправляемый в BIOLOID
#define PowBit 5   // 0b10X00000- рубильник включен &
#define PumpBit 4  // 0b100X0000- насос включен &
#define CupBit 3   // 0b1000X000- фужер установлен &
#define MoneyBit 2  //0b10000X00- есть монеты в монетоприемнике &
#define ActionBit 1 //0b100000X0- акция разрешена &
#define MoveBit 0   //0b1000000X- сработал датчик движения

// МОНЕТОПРИЕМНИК
int MoneyCount=0; // счетчик монет
int WaitMoneyCount=0; //счетчик ожидания приема следующей монеты до выполнения налива
#define WaitMoneyLim 8000 //время ожидания приема следующей монеты в мС
boolean MoneyBlockFlag=false; //запрет приема монет в монетоприемник
boolean MoneyActionFlag=false; // начало выпонения действий, после приема монет (одной или нескольких)

// СВЕТОДИОДНАЯ ПОДСВЕТКА "СИЛОВОЙ ПАНЕЛИ" 
#define PCFADR 0x20 // в библиотеке Wire используется сдвинутый 7-битный адрес PCF8574(0x20 вместо 0x40)
byte LedsStatus=0xFF; //состояние дисплея индикации количества монет (1- сегмент горит)
//byte MoneyLeds=1; //индикация счетчика монет
#define LEDON LOW
#define LEDOFF HIGH
byte MoneyLedStatus=LEDON; //Состояние светодиода подсветки монетоприемника (низкий уровень - горит)

int DisplayCount=0; //счетчик задержки для индикации
byte LedCount=0; //счетчик переключения светодиодов для бегущего огня.
#define DisplayWaitLim 50 //Частота переключения бегущего огня в мС
boolean DisplayUpFlag=true; // направление бегущего огня вверх

int BlinkCount=0; //счетчик задержки для светодиода подсветки
int BlinkFreq=500; //Частота мигания в мС
byte BlinkMask=0xFF;

// СВЕТОДИОДНАЯ ПОДСВЕТКА ФУЖЕРА
byte CupLedModo=0;
byte OldCupLedModo=0;
#define CupLedOff 0 //- погашен
#define Rblink 1 //- мигание красным (нет фужера при брошенной манете, аварийное отключение, переполненый фужер)
#define fader 2 // начало фейдеров
#define Bfader 2 //- синий фейдер (пустой фужер)
#define GBfader 3 //- сине-зеленый фейдер (процесс налива)
#define Gfader 4 //- зеленый фейдер (налив закончен)
#define RGBfader 5//- красно-сине зеленый фейдер (ожидание)

byte CurrentVoltage=0; //текущее выходное напряжение 
byte CurrentPort=red; //текущий светодиод (включаем по одному, чтобы уменьшить потребление
byte LightMax[]={80,80,80}; //Ограничение яркости R,G,B
int CupLedCount=0; //счетчик задержки для светодиода подсветки фужера
#define CupLedBlinkFreq 500 //Частота мигания в мС
#define CupLedFaderFreq 10 //Частота переключения фейдера в мС
boolean ReversFlag=false;

// КОНТРОЛЬ НАЛИЧИЯ ФУЖЕРА (ДАТЧИК ВЕСА)
int CupCount=0;
#define CupTestFreq 500 //интервал в мс через который проверяется наличие фужера
int CupCalibrate; // показания датчика при отсутствии фужера.
int CupEmpty; // разница между отсутствием фужера и пустым фужером
int CupFull; // разница между отсутствием фужера и полным до краев  фужером
#define pCupEmpty 20 // разница между отсутствием фужера и пустым пластиковым фужером
#define pCupFull 200 // разница между отсутствием фужера и полным до краев пластиковым фужером
#define gCupEmpty 180 // разница между отсутствием фужера и пустым стеклянным фужером
#define gCupFull 270 // разница между отсутствием фужера и полным до краев стеклянным фужером
boolean CapFlag=false;
boolean NewCapFlag=false;
boolean FinNalivFlag=false;

// НАСОС
byte PumpSpeed=0;
#define PumpSpeedMin 180
#define PumpSpeedMax 220
boolean PumpFunctionFlag=false;
boolean PumpMinFlag=false;
int PumpCount=0; //счетчик времени функционирования насоса.
int PumpStartCount=0; //счетчик времени разгона насоса.
#define DrinkLim 5000 //Время налива одной порции в мС
#define PumpStartLim 1000 //Время разгона в мС

//ПРОИГРЫВАТЕЛЬ ЗВУКОВ (WTV)
byte language=0; // выбор языка для звукового файла ( англ /русский/ испанский) 

#define cmd_play 0xFFFE
#define cmd_stop 0xFFFF
#define WTSCL_LOW   digitalWrite(WTSCL, LOW) 
#define WTSCL_HIGH  digitalWrite(WTSCL, HIGH)
#define WTSDA_LOW   digitalWrite(WTSDA, LOW)
#define WTSDA_HIGH  digitalWrite(WTSDA, HIGH)
boolean WTbusyFlag=false;
// коды звуков
#define WTbienvenidos 0 // установлено соединение с роботом, программа запущена 
#define WTrobotnotconnect 1 // робот не подключен (не используется)
#define WTrobotmov 2 // звук сервомотора
#define WTpoweron 3 // включение рубильника
#define WTmoney 4 // звук монеты
#define WTpumpstart 5 // включение насоса
#define WTbulk 6 // бульканье при наливе
#define WTpumpstop 7 // выключение насоса
// коды голосовых фраз (по одной фразе на событие)
#define WTrVoice 10 //голос робота (10...49 - англ, 50-89 рус, 90...119 )
#define rHellow 0 //10- приветствие
#define rHelp 1 //11- просит помочь со шлангом (только по инициативе робота)
#define rMaxLevel 2 //12- максимальный уровень
#define rServeYou 3 //13- к вашим услугам (только по инициативе робота)
#define rCapRec 4 //14- поставьте бокал (только по инициативе робота)
// коды голосовых фраз (5 фраз на событие)
#define rCap 5//15...19 - реакция на установку фужера, если монета еще не брошена
//#define maxrCap 2
#define rFirstCoin 10//20...24 - после первой брошенной монеты
//#define maxrFirstCoin 3
#define rNextCoin 15//25...29 - после следующей брошенной монеты
//#define maxrNextCoin 4
#define rGoPure 20//30...34 - пошел наливать
//#define maxrGoPure 2
#define rNextCap 25//35...39 - просит следующий фужер
//#define maxrNextCap 2
#define rHellowSeated 30//40...44 - приветствие при срабатывании детектора движения (только по инициативе робота)
//#define maxrHellowSeated 2
#define rReservFrase 35//45...49 - резерв.
byte rCurrentFrase[]={0,0,0,0,0,0,0};

#define WTvolumelevelmin 0xFFF3
#define WTvolumelevelmax 0xFFF7
boolean SoundOFF=false; //выключение звука
int TestCount=0;

//ДАТЧИК ДВИЖЕНИЯ 
boolean MoveLockFlag=false;
#define MoveLockLim 2//Время блокировки датчика движений в минутах.
long MoveLockCount=0;

/************************************************************************************************/

void PlayCurrentFrase(byte VoiceIndex)   //ПРОИГРЫВАНИЕ ГОЛОСОВОЙ ФРАЗЫ (одной из 5-ти по очереди)
{
	unsigned int frase=language+WTrVoice+VoiceIndex;
	VoiceIndex=VoiceIndex/5-1;
	Play(frase+rCurrentFrase[VoiceIndex]);
	rCurrentFrase[VoiceIndex]++; if(rCurrentFrase[VoiceIndex]>4)rCurrentFrase[VoiceIndex]=0;
}
void Play(unsigned int PlayNumber)   //ПРОИГРЫВАНИЕ ЗВУКОВОГО ФАЙЛА
{
   if(SoundOFF)return;
	 noInterrupts();
  //int ErrCount=0;
   SendToWt(PlayNumber); 
   delay(100);
   if(!digitalRead(WTBUSY))SendToWt(PlayNumber); //повторная попытка, если первая не удалась
   interrupts(); 
}
void SendToWt(unsigned int WTdat)         //ПЕРЕДАЧА ДАННЫХ ЗВУКОВОМУ МОДУЛЮ
{
  unsigned int i;

  WTSCL_LOW; 
  delay(2);      // состояние начала передачи
  for(i=0x8000;i>0;i>>=1)         // передаем, начиная со старшего бита
  {
    delayMicroseconds(20);
    if(WTdat & i)WTSDA_HIGH;
    else WTSDA_LOW;
    delayMicroseconds(100); 
    WTSCL_HIGH;  //данные записываются по положительному фронту SCL
    delayMicroseconds(100); 
    if(i>1)WTSCL_LOW; //после последнего бита не сбрасываем SCL 
  }
  //WTSCL_HIGH;
  //delay(20);
  //WTSDA_HIGH;
}
void CheckCup() // проверяем наличие фужера и управляем режимом подсветки
{
 CupCount++; 
 if(CupCount>CupTestFreq/SCANCYC)
// if(CupCount>CupFreq/SCANCYC)
 {
  CupCount=0; 
  int CupWeight=analogRead(CupContr)-CupCalibrate;
  if(CupWeight>CupEmpty && CupWeight<CupFull) //фужер установлен и не полон
  {
		if(!CapFlag)
		{
			SETBIT(ArdStatus,CupBit);
			CapFlag=true; 
			NewCapFlag=true;
			if(!MoneyCount)PlayCurrentFrase(rCap);//
		}
		if(MoneyCount)CupLedModo=Bfader; //есть фужер, есть монеты, налив не начат
		else 
    {
      if(!NewCapFlag)CupLedModo=Gfader; //есть фужер, налив закончен
	  else CupLedModo=RGBfader; //есть фужер, нет монет, налив не начат
    }
    if(PumpFunctionFlag)CupLedModo=GBfader; //есть фужер, идет налив
  }
  else
  {
    if(CapFlag){CLEARBIT(ArdStatus,CupBit);CapFlag=false;}
    if(MoneyCount) CupLedModo=Rblink; //нет фужера, есть монеты
    else CupLedModo=CupLedOff; //нет фужера, нет монет
    if(CupWeight>CupFull) //фужер полон
    {
     if(PumpFunctionFlag) PumpStop(); //аварийный останов налива
     CupLedModo=Rblink;
    }
  }
 }
}
void CheckPower() // проверка напряжения после рубильника
{
  // ArdStatus=analogRead(Contr12);
  if(analogRead(Contr12)>10) //есть напряжение 
  {
    if(!GETBIT(ArdStatus,PowBit)) //напряжение появилось 
    {
      SETBIT(ArdStatus,PowBit);
      Play(WTpoweron);
      //if(OtladkaFlag)PumpStart(); //при отладке сразу запускается насос при включении рубильника
    }
  }
  else
  {
    if(GETBIT(ArdStatus,PowBit)) //напряжение пропало
    {
      if(PumpFunctionFlag)PumpStop();
      CLEARBIT(ArdStatus,PowBit);
      if(OtladkaFlag)MoneyBlockFlag=false;
      MoneyCount=0;
    }

  }
}
void TxEnable() //разрешает передачу RS232
{
  digitalWrite(rxen, HIGH);
  digitalWrite(txen, LOW); 
} 
void RxEnable() //разрешает прием RS232
{
  digitalWrite(txen, HIGH);
  digitalWrite(rxen, LOW); 
} 
void PumpStart() //плавный разгон насоса
{
  if(!MoneyCount)return;
  MoneyBlockFlag=true; //с монента запуска насоса не принимаем монеты, до исходного состояния
  //PumpSpeed=PumpSpeedMax;
  PumpStartCount=0;
  Play(WTpumpstart);
  SETBIT(ArdStatus,PumpBit);
  PumpMinFlag=false;
  PumpFunctionFlag=true;
  analogWrite(PumpPort, PumpSpeedMax);
} 
void CheckPump() // контроль времени работы насоса
{
  if(PumpFunctionFlag)
  {
    if(PumpStartCount<PumpStartLim/SCANCYC) PumpStartCount++;// разгон насоса
    else 
    {
      if(!PumpMinFlag){analogWrite(PumpPort, PumpSpeedMin); PumpMinFlag=true;}
	  else
	  {
	    PumpCount++;
		if(PumpCount>DrinkLim/SCANCYC) //контроль времени налива.
		{
		  PumpCount=0;
		  MoneyCount--;
		  if(MoneyCount<1)PumpStop();
		}
	  }
    }
  }
}
void PumpStop() //останов насоса
{
  analogWrite(PumpPort,0);
  MoneyCount=0;
  CLEARBIT(ArdStatus,MoneyBit);
  CLEARBIT(ArdStatus,PumpBit);
  PumpFunctionFlag=false;
  //if(!OtladkaFlag) MoneyBlockFlag=true; //с монента останова насоса не принимаем монеты, до исходного состояния
	NewCapFlag=false;
  //CupLedModo=Gfader;
  Play(WTpumpstop);
}
void money() // Выполняется при каждом получении монеты в монетоприемник (по прерыванию)
{
  //detachInterrupt(MoneyInt);
  if(MoneyBlockFlag || !InitFlag)return;
  SETBIT(ArdStatus,MoneyBit);
  Play(WTmoney);
  MoneyCount++;
  if(MoneyCount>4) MoneyCount=4; //максимальное количество монет 4 - определяет уровень налива
  WaitMoneyCount=0;
  // if(GETBIT(ArdStatus,CupBit))CupLedModo=Bfader;else CupLedModo=BlinkRed;
}
void CheckMoveState()//контроль движения
{

  if(!digitalRead(MoveSensor)) // сработал датчик движения
  {
	if(!MoveLockFlag)
	{
		SETBIT(ArdStatus,MoveBit); 
		MoveLockFlag=true;
		MoveLockCount=0;
	}
  }
  else CLEARBIT(ArdStatus,MoveBit);
  if(MoveLockFlag)
  {
	MoveLockCount++;
	if(MoveLockCount>MoveLockLim*1000*60/SCANCYC)MoveLockFlag=false;
  }
}

void CheckTestBtn()//фунуции тестовой кнопки
{
  if(!digitalRead(TestButton))// нажата тестовая кнопка
  {
     if (InitFlag)money(); else RobotStatus=10;
     while(!digitalRead(TestButton));
     delay(100); 
   }
}


void MoneyDisplay() //выполняется каждый цикл
{
  BlinkCount++;

  if(BlinkCount>BlinkFreq/SCANCYC) // мигаем подсветкой или дисплеем
  {
    BlinkCount=0;
    MoneyLedStatus=!MoneyLedStatus;
    if(!MoneyActionFlag && !MoneyBlockFlag)digitalWrite(MoneyLed,MoneyLedStatus);
    else digitalWrite(MoneyLed,LEDOFF);
    BlinkMask=~(BlinkMask);
  }
  if(MoneyCount)
  {
    BlinkFreq=1000; //увеличиваем период мигания
    if(!MoneyActionFlag)
     {
        WaitMoneyCount++; //ждем добавления монет
        if(MoneyCount>3)WaitMoneyCount=WaitMoneyLim/SCANCYC+10;
     }
    if(WaitMoneyCount==WaitMoneyLim/2/SCANCYC) //напомним, что хорошо бы бросить еще монетку
    {
	if(MoneyCount==1)PlayCurrentFrase(rFirstCoin);
	else PlayCurrentFrase(rNextCoin);
    }
    if(WaitMoneyCount>WaitMoneyLim/SCANCYC) 
    {
      WaitMoneyCount=0;
      MoneyActionFlag=true; //можем начинать выполнение действий
      SETBIT(ArdStatus,ActionBit);
	  if(MoneyCount>3)Play(language+WTrVoice+rMaxLevel); //брошено максимальное количество монет
	  else PlayCurrentFrase(rGoPure);//пошел наливать
    }
    LedsStatus=0xFF>>8-MoneyCount*2; //отображаем количество монет
    if(MoneyActionFlag)
    {
      LedsStatus &=BlinkMask; //мигаем дисплеем, 
      digitalWrite(MoneyLed,LEDOFF); // отключаем подсветку
    }
  }
  else
  {
    if(MoneyBlockFlag)LedsStatus=0; //дисплей погашен
    else							//бегущий огонь
    {
      BlinkFreq=500; //уменьшаем период мигания
      DisplayCount++;
      if(DisplayCount>DisplayWaitLim/SCANCYC)
      {
        DisplayCount=0;
        if(!DisplayUpFlag)LedsStatus=B10000000>>LedCount;
        else LedsStatus=1<<LedCount; //
        LedCount++;
        if(LedCount>9)
        {
          LedCount=0;
          DisplayUpFlag=!DisplayUpFlag;
        }
      }
    }
  }
  SetLeds();
}

void SetLeds()
{
  Wire.beginTransmission(PCFADR);     //Begin the transmission to PCF8574
  Wire.write(~(LedsStatus));             //Send the data to PCF8574
  Wire.endTransmission();            //End the Transmission
}

void CapLedShow()
{
  if(CupLedModo!=OldCupLedModo){OldCupLedModo=CupLedModo;RGBoff();}
  CupLedCount++;
  switch(CupLedModo)
  {
  case Rblink: //мигание красным
    {
      CurrentPort=red;
//      analogWrite(green,0);
//      analogWrite(blue,0);
      if(CupLedCount>CupLedBlinkFreq/SCANCYC)
      {
        CupLedCount=0;
        if(CurrentVoltage)CurrentVoltage=0;
        else CurrentVoltage=LightMax[red-9];
      }
      analogWrite(CurrentPort,CurrentVoltage);
      break;
    }
  case Bfader: //синий фейдер
    {
      analogWrite(red,0);
      analogWrite(green,0);
      CurrentPort=blue;
      break;
    }
  case GBfader: //сине-зеленый фейдер
    {
//      analogWrite(red,0);
      if(CurrentPort==green)
      {
        if(!CurrentVoltage)CurrentPort=blue;
      }
      else
      {
        if(!CurrentVoltage)CurrentPort=green;
      }
      break;
    }
  case Gfader: //зеленый фейдер
    {
//      analogWrite(red,0);
//      analogWrite(blue,0);
      CurrentPort=green;
      break;
    }
  case RGBfader: //красно-сине зеленый фейдер
    {
      if(!CurrentVoltage)
      {
        CurrentPort++;
        if(CurrentPort>11)CurrentPort=9;
      }
      break;
    }
  default:
    {
      RGBoff();
      CurrentVoltage=0;
      CurrentPort=red;
      CupLedCount=0;
    }

  }
  if(CupLedModo>=fader) //фейдер в работе
  {
    if(CupLedCount>CupLedFaderFreq/SCANCYC)
    {
      CupLedCount=0;
      if(ReversFlag)CurrentVoltage--;else CurrentVoltage++;
      if(!CurrentVoltage)ReversFlag=false; 
      if(CurrentVoltage>LightMax[CurrentPort-9])
      {
        CurrentVoltage=LightMax[CurrentPort-9];
        ReversFlag=true;
      }
      analogWrite(CurrentPort,CurrentVoltage);
     }
  }
   
}
void RGBoff()
{
  analogWrite(red,0);
  analogWrite(green,0);
  analogWrite(blue,0);
}

void serialEvent() // Возникает при поступлении байта в посл порт
{
  GetCmd();
}

void  GetCmd()// Распознает Instruction Packet, поступающий от контроллера BIOLOID
{			  // Обрабатывается только пакет, адресованный MyID (Dinamixel Slave)
  // При инструкции записи в регистр любого адреса, считывается статус робота (инструкция должна предполагать передачу одного байта)
  // При инструкции чтения регистра из любого адреса, роботу передается байт статуса Ардуино (инструкция должна предполагать получение одного байта)
  // Остальные типы инструкций игнорируются
  while(Serial.available())            // Пока в буфере есть что читать 
  {
    byte inChar = (byte)Serial.read();     // Читаем очередной байт из буфера


    if(CheckCount>3) // получен Instruction Packet
    {
	  //if(CheckCount==4)  digitalWrite(13, HIGH);  //отладка
      DatosBioloid[CheckCount]=inChar; //получаем данные
      if(CheckCount>5)//получен полный пакет данных
      {
        CheckCount=0;
        DatosFlag=true; 
      }
      else CheckCount++;
    }
    else
    {
      if(inChar==DatosBioloid[CheckCount])CheckCount++; //проверяем последовательность байтов "на лету" на наличие Instruction Packet
      else CheckCount=0; 
    }
  }
  if(DatosFlag)
  {
    DatosFlag=false;
    if(DatosBioloid[4]==ReadData) Response(); // Получен запрос данных, передаем байт статуса ARD
    else if(DatosBioloid[4]==WriteData)// Получение статуса Bioloid
    {
      RobotStatus=DatosBioloid[6];
      StatusResponse();
    }
  }
}

void Response()//посылаем  пакет с байтом данных контроллеру BIOLOID
{
  delayMicroseconds(10); // пауза
  TxEnable();
  delayMicroseconds(5);
  Serial.write(startByte);
  Serial.write(startByte);
  Serial.write(MyID);
  Serial.write(Wlen);
  Serial.write(ErByte);
  Serial.write(ArdStatus);
  Serial.write((~(MyID + Wlen + ErByte + ArdStatus))&0xFF); // контрольная сумма
  delayMicroseconds(100);
  RxEnable();
  //delay(500);     //отладка          
  //digitalWrite(13, LOW);  //отладка 
  //delay(1000);     //отладка          
}
void StatusResponse()//посылаем статусный пакет контроллеру BIOLOID
{
  delayMicroseconds(10); // пауза
  TxEnable();
  delayMicroseconds(5);
  Serial.write(startByte);
  Serial.write(startByte);
  Serial.write(MyID);
  Serial.write(2);
  Serial.write(ErByte);
  Serial.write((~(MyID + 2 + ErByte))&0xFF); // контрольная сумма
  delayMicroseconds(100);
  RxEnable();
  //delay(1000);     //отладка          
  //digitalWrite(led, LOW);  //отладка  
}

void CheckRobotStatus()
{
  if(RobotStatus!=RobotOldStatus)// реагируем только на изменение статуса
  {
    RobotOldStatus=RobotStatus;
    switch(RobotStatus)
    {   
    case 10:   // робот в исходном состоянии
      {
        ActionTerminated();
        if(!InitFlag)Play(WTbienvenidos);
        InitFlag=true;
        break;
      }
	case 20:   // робот начал движение
      {
        Play(WTrobotmov);
        break;
      }
    case 40:   // робот готов к наливу
      {
        PumpStart();
        break;
      }
	  case 45:   // робот ждет следующий бокал
      { 
        ActionTerminated();
        if(!MoneyCount)PlayCurrentFrase(rNextCap);
        break;
      }
    case 50:   // аварийный останов налива
      {
        PumpStop();
        break;
      }
    case 60:   // выключить звук
      {
        SoundOFF=true;
        break;
      }
    case 65:   // включить звук
      {
        SoundOFF=false;
        break;
      }
    case 30:   // заблокировать прием монет
      {
        MoneyBlockFlag=true;
        break;
      }
	case 35:   // произнести фразу при возникновении движения
      {
		PlayCurrentFrase(rHellowSeated);
		CLEARBIT(ArdStatus,MoveBit);
		break;
      }
    default:
      {
        if(RobotStatus>=70 & RobotStatus<119)
		{
		if(!SoundOFF) // произносит фразу с номером (10...49 - англ, 50-89 рус, 90...119 )
		{
			if(RobotStatus>74)PlayCurrentFrase(RobotStatus-70);else Play(RobotStatus-60+language); 
		}
        else		//переключение языка
			{
				SoundOFF=false;
				language+=40;
				if(language>80)language=0;
				EEPROM.write(SafeLeng, language);
				Play(language+WTrVoice+rHellow); // произносит фразу приветствия на выбранном языке
			}
		}
		break;
      }
    }

  }
}
void ActionTerminated()
{
 CLEARBIT(ArdStatus,ActionBit);
 MoneyActionFlag=false;
 MoneyBlockFlag=false;  
}

void setup() 
{  
  byte i;
  pinMode(led, OUTPUT);
  pinMode(txen, OUTPUT);
  pinMode(rxen, OUTPUT); 
  pinMode(MoneyLed, OUTPUT);
  pinMode(WTSDA, OUTPUT);
  WTSDA_HIGH;
  pinMode(WTSCL, OUTPUT);
  WTSCL_HIGH;
  pinMode(WTBUSY, INPUT);
  // digitalWrite(WTBUSY, LOW); // отключить подтягивающий резистор
  pinMode(TestButton, INPUT_PULLUP); // тестовая кнопка
  pinMode(MoveSensor, INPUT_PULLUP); // датчик движения
  CapLedShow();
  for(i=0;i++;i<7)rCurrentFrase[i]=int(random(4)); //случайная установка начальных фраз
  Serial.begin(1000000);//init Serial baudrate
// SoundOFF=true;
  //attachInterrupt(MoneyInt, money, RISING); // привязываем 0-е прерывание к money()при изменении уровня напряжения с низкого (LOW) на высокое (HIGH)
  //detachInterrupt(MoneyInt);
  RxEnable();
  Wire.begin();
  delay(1000);
  if(!digitalRead(TestButton)){OtladkaFlag=true; SoundOFF=true;} //если тестовая кнопка нажата при подаче питания, включаем отладку, выключаем звук
  SetLeds();
  //interrupts(); 
  language = EEPROM.read(SafeLeng); // загрузка последнего выбранного языка
  if(language!=0 && language!=40 && language!=80)
  {
	language=0;
	EEPROM.write(SafeLeng, language);
  }	
  delay(3000);

//  while(RobotStatus!=10) //ожидаем подключения робота и установки его в исходное положение
//    {
//	   if(InitComFlag)RobotStatus=10; //при получении любого пакета от робота запускаем программу
//       if(!digitalRead(TestButton)) //если тестовая кнопка нажата запускаем программу
//      {
//        RobotStatus=10;
//        while(!digitalRead(TestButton));
//        delay(1000);
//      }
//      delay(1);
//    }
  
  attachInterrupt(MoneyInt, money, RISING); // привязываем 0-е прерывание к money()при изменении уровня напряжения с низкого (LOW) на высокое (HIGH)
  CupCalibrate=analogRead(CupContr); // калибровка датчика веса (фужер д.б. снят)
  CupEmpty=pCupEmpty;
  CupFull=pCupFull;
  ArdStatus=0b10000000; // Статус  байт, отправляемый в BIOLOID (0b10XXXXXX контроллер готов к работе)
}

void loop() 
{
  CheckTestBtn(); //проверяем состояние тестовой кнопки
  CheckRobotStatus(); //проверяем текущий статус робота
  if (InitFlag)
  {
    CheckMoveState(); // проверяем состояние датчика движения
    MoneyDisplay(); //управляем подсветкой дисплея
    CheckCup(); //проверяем наличие фужера
    CapLedShow(); //управляем подсветкой фужера
    CheckPower(); //проверяем включен ли рубильник
    CheckPump(); //следим за временем налива
  }
  //ArdStatus=RobotStatus; //отладка  
  delay(SCANCYC); 
}



